Imports DES.PopulationGrowth.Events
Imports MathNet.Numerics.Distributions

Namespace DES.PopulationGrowth.Objects
	Public Class Female
		Inherits Individual

		Public Property IsPregnant As Boolean

		Public Property PregnancyAge As Double

		Public Property ChildrenCount As Double

		Public Sub New(ByVal age As Integer)
			MyBase.New(age)
		End Sub

		Public Function SuitablePregnancy(ByVal currentTime As Integer) As Boolean
			Return Age >= PregnancyAge AndAlso currentTime <= TimeChildren AndAlso ChildrenCount > 0
		End Function

        Public Function GiveBirth(ByVal distributions As Dictionary(Of [Event], IDistribution), ByVal currentTime As Integer) As Individual
            Dim sample = (CType(distributions([Event].BirthEngageDisengage), ContinuousUniform)).Sample
            Dim child = If(sample > 0.5, CType(New Male(0), Individual), New Female(0))

            ' One less child
            ChildrenCount -= 1

            child.LifeTime = (CType(distributions([Event].Die), Poisson)).Sample
            child.RelationAge = (CType(distributions([Event].CapableEngaging), Poisson)).Sample

            If TypeOf child Is Female Then
                TryCast(child, Female).PregnancyAge = (CType(distributions([Event].GetPregnant), Normal)).Sample
                TryCast(child, Female).ChildrenCount = (CType(distributions([Event].ChildrenCount), Normal)).Sample
            End If

            If Engaged AndAlso ChildrenCount > 0 Then
                TimeChildren = currentTime + (CType(distributions([Event].TimeChildren), Exponential)).Sample
                Couple.TimeChildren = TimeChildren
            Else
                TimeChildren = 0
            End If

            IsPregnant = False
            Return child
        End Function

        Public Overrides Function ToString() As String
			Return MyBase.ToString & " Female"
		End Function
	End Class
End Namespace
